function [p,R] = quatrot(q,p)
    a = q(1);
    b = q(2);
    c = q(3);
    d = q(4);

    R(1,1) = a*a + b*b - c*c - d*d;
    R(2,2) = a*a - b*b + c*c - d*d;
    R(3,3) = a*a - b*b - c*c + d*d;
    R(1,2) = 2*(b*c-a*d);
    R(1,3) = 2*(a*c+b*d);
    R(2,3) = 2*(c*d-a*b);
    R(2,1) = 2*(a*d+b*c);
    R(3,1) = 2*(b*d-a*c);
    R(3,2) = 2*(a*b+c*d);

    if nargin < 2
        p = R;
    else
        p = R*p;
    end
end
